'use strict';

var utils = require('../utils/writer.js');
var User = require('../service/UserService');
var passport = require('../passeport-config')

module.exports.createUser = async function(req, res) {
    try {
        const { username, password, isAgent } = req.body;
        await User.createUser(username, password, isAgent);
        utils.writeJson(res, { message: 'Utilisateur créé avec succès' });
    } catch (error) {
        utils.writeJson(res, { error: error.message });
    }
};

module.exports.loginUser = async function loginUser(req, res) {
    passport.authenticate('local', (err, user, info) => {
        console.log("-----", req.body);
        if (err) {
            throw new Error(err);
        }
        if (!user) {
            throw new Error('Invalid username or password.');
        }
        req.logIn(user, (err) => {
            if (err) {
                throw new Error(err);
            }
            return true;
        });
    })(req, res);
}

module.exports.logoutUser = function logoutUser (req, res, next) {
  User.logoutUser()
    .then(function (response) {
      utils.writeJson(res, response);
    })
    .catch(function (response) {
      utils.writeJson(res, response);
    });
};

module.exports.updateUser = function updateUser (req, res, next, body, username) {
  User.updateUser(body, username)
    .then(function (response) {
      utils.writeJson(res, response);
    })
    .catch(function (response) {
      utils.writeJson(res, response);
    });
};

module.exports.updateUser = function updateUser (req, res, next, body, username) {
  User.updateUser(body, username)
    .then(function (response) {
      utils.writeJson(res, response);
    })
    .catch(function (response) {
      utils.writeJson(res, response);
    });
};
